/************************************************************************
	delay.c

    Simon18F - An MB Electronics Simon clone based on the PIC18F2550
    Copyright (C) 2009 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

// Global includes
#include <htc.h>

#include "delay.h"
#include "hardware.h"

void delayMilliSeconds(int milliSeconds)
{
	// This delay routine uses a long int (32 bit) counter which is 
	// incremented on every timer0 interrupt.
	//
	// The actual delay depends on the speed of the interrupt and the
	// execution time.  It can be tuned by oscillating a pin and
	// measuring the delay using a oscilloscope.

	long delayComparison;

	hardware.delayCounter = 0;

	// Starting with 23 I kept reducing the figure (to allow for the overhead)
	// until 10 milliseconds delay was accurate (the delay was measured with
	// an oscilloscope)
	delayComparison = 6 * milliSeconds;

	while (hardware.delayCounter < delayComparison);
}