/************************************************************************
	spi.c

    Simon18F - An MB Electronics Simon clone based on the PIC18F2550
    Copyright (C) 2009 Simon Inns

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Email: simon.inns@gmail.com

************************************************************************/

// Global includes
#include <htc.h>

// Local includes
#include "hardware.h"
#include "spi.h"

// Write 16 bits to the A6276 controller
void SPIwrite(unsigned char byte1, unsigned char byte2)
{
	// Disable latching
	CS_LED = 0;

	// Write the low byte
	SSPIF = 0;
	SSPBUF = byte1;
	while(!SSPIF); // Wait for transmit to complete

	// Write the high byte
	SSPIF = 0;
	SSPBUF = byte2;
	while(!SSPIF); // Wait for transmit to complete

	// Enable latching
	CS_LED = 1;
}

void setVolumeLevel(void)
{
	// Set the volume level
	CS_POT = 1;
	CS_LED = 0;

	CS_POT = 0;
	SSPIF = 0;
	SSPBUF = 0b00010011;
	while(!SSPIF); // Wait for transmit to complete

	SSPIF = 0;
	SSPBUF = hardware.volumeLevel;
	while(!SSPIF); // Wait for transmit to complete
	CS_POT = 1;

	hardware.currentVolumeLevel = hardware.volumeLevel;
}